Object.defineProperty(exports,"__esModule",{value:true});var _extends=Object.assign||function(target){for(var i=1;i<arguments.length;i++){var source=arguments[i];for(var key in source){if(Object.prototype.hasOwnProperty.call(source,key)){target[key]=source[key];}}}return target;};var _createClass=function(){function defineProperties(target,props){for(var i=0;i<props.length;i++){var descriptor=props[i];descriptor.enumerable=descriptor.enumerable||false;descriptor.configurable=true;if("value"in descriptor)descriptor.writable=true;Object.defineProperty(target,descriptor.key,descriptor);}}return function(Constructor,protoProps,staticProps){if(protoProps)defineProperties(Constructor.prototype,protoProps);if(staticProps)defineProperties(Constructor,staticProps);return Constructor;};}();var _immutable=require('immutable');var _immutable2=_interopRequireDefault(_immutable);
var _react=require('react');var _react2=_interopRequireDefault(_react);
var _reactNative=require('react-native');function _interopRequireDefault(obj){return obj&&obj.__esModule?obj:{default:obj};}function _classCallCheck(instance,Constructor){if(!(instance instanceof Constructor)){throw new TypeError("Cannot call a class as a function");}}function _possibleConstructorReturn(self,call){if(!self){throw new ReferenceError("this hasn't been initialised - super() hasn't been called");}return call&&(typeof call==="object"||typeof call==="function")?call:self;}function _inherits(subClass,superClass){if(typeof superClass!=="function"&&superClass!==null){throw new TypeError("Super expression must either be null or a function, not "+typeof superClass);}subClass.prototype=Object.create(superClass&&superClass.prototype,{constructor:{value:subClass,enumerable:false,writable:true,configurable:true}});if(superClass)Object.setPrototypeOf?Object.setPrototypeOf(subClass,superClass):subClass.__proto__=superClass;}

var isImmutableIterable=_immutable2.default.Iterable.isIterable;











function getKeys(immutableData){
if(__DEV__&&!isImmutableIterable(immutableData)){
console.warn('Can\'t get keys: Data is not Immutable: '+JSON.stringify(immutableData));
}

return immutableData.keySeq().toArray();
}











function getRowIdentities(immutableSectionData){
if(__DEV__&&!isImmutableIterable(immutableSectionData)){
console.warn('Can\'t get row identities: Data is not Immutable: '+JSON.stringify(immutableSectionData));
}

var sectionRowKeys=immutableSectionData.map(getKeys);
return sectionRowKeys.valueSeq().toArray();
}






function getValueFromKey(key,data){
return typeof data.get==='function'?data.get(key):data[key];
}var





ImmutableListView=function(_PureComponent){_inherits(ImmutableListView,_PureComponent);function ImmutableListView(){var _ref;var _temp,_this,_ret;_classCallCheck(this,ImmutableListView);for(var _len=arguments.length,args=Array(_len),_key=0;_key<_len;_key++){args[_key]=arguments[_key];}return _ret=(_temp=(_this=_possibleConstructorReturn(this,(_ref=ImmutableListView.__proto__||Object.getPrototypeOf(ImmutableListView)).call.apply(_ref,[this].concat(args))),_this),_this.





































state={
dataSource:new _reactNative.ListView.DataSource({
rowHasChanged:function rowHasChanged(prevRowData,nextRowData){return!_immutable2.default.is(prevRowData,nextRowData);},

getRowData:function getRowData(dataBlob,sectionID,rowID){
var rowData=getValueFromKey(sectionID,dataBlob);
return getValueFromKey(rowID,rowData);
},

sectionHeaderHasChanged:_this.props.sectionHeaderHasChanged,

getSectionHeaderData:function getSectionHeaderData(dataBlob,sectionID){return getValueFromKey(sectionID,dataBlob);}}),


interactionOngoing:true},_temp),_possibleConstructorReturn(_this,_ret);}_createClass(ImmutableListView,[{key:'componentWillMount',value:function componentWillMount()


{
this.setStateFromPropsAfterInteraction(this.props);
}},{key:'componentWillReceiveProps',value:function componentWillReceiveProps(

newProps){
this.setStateFromPropsAfterInteraction(newProps);
}},{key:'setStateFromPropsAfterInteraction',value:function setStateFromPropsAfterInteraction(

props){var _this2=this;

this.setStateFromProps(props,false);


if(props.rowsDuringInteraction>=0){
_reactNative.InteractionManager.runAfterInteractions(function(){
_this2.setStateFromProps(props,true);
});
}
}},{key:'setStateFromProps',value:function setStateFromProps(

props,interactionHasJustFinished){var _state=
this.state,dataSource=_state.dataSource,interactionOngoing=_state.interactionOngoing;var
immutableData=props.immutableData,rowsDuringInteraction=props.rowsDuringInteraction,renderSectionHeader=props.renderSectionHeader;

var shouldDisplayPartialData=rowsDuringInteraction>=0&&interactionOngoing&&!interactionHasJustFinished;

var displayData=shouldDisplayPartialData?
immutableData.slice(0,rowsDuringInteraction):
immutableData;

this.setState({
dataSource:renderSectionHeader?
dataSource.cloneWithRowsAndSections(displayData,getKeys(displayData),getRowIdentities(displayData)):
dataSource.cloneWithRows(displayData,getKeys(displayData)),

interactionOngoing:interactionHasJustFinished?false:interactionOngoing});

}},{key:'render',value:function render()

{var
dataSource=this.state.dataSource;


return(
_react2.default.createElement(_reactNative.ListView,_extends({
dataSource:dataSource,
enableEmptySections:true},
this.props)));


}}]);return ImmutableListView;}(_react.PureComponent);ImmutableListView.propTypes=_extends({},_reactNative.ListView.propTypes,{dataSource:_react.PropTypes.oneOf([undefined]),immutableData:function immutableData(props,propName,componentName){if(!isImmutableIterable(props[propName])){return new Error('Invalid prop '+propName+' supplied to '+componentName+': Must be Immutable.Iterable.');}},sectionHeaderHasChanged:_react.PropTypes.func,rowsDuringInteraction:_react.PropTypes.number});ImmutableListView.defaultProps=_extends({},_reactNative.ListView.getDefaultProps(),{sectionHeaderHasChanged:function sectionHeaderHasChanged(prevSectionData,nextSectionData){return false;}});exports.default=



ImmutableListView;